package com.jasamedika.medifirst2000.service.impl;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.stereotype.Service;

import com.jasamedika.medifirst2000.converter.FisisPemeriksaanDokterConverter;
import com.jasamedika.medifirst2000.dao.FisisPemeriksaanDokterDao;
import com.jasamedika.medifirst2000.entities.FisisPemeriksaanDokter;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.FisisPemeriksaanDokterService;
import com.jasamedika.medifirst2000.service.FisisPemeriksaanDokterService;
import com.jasamedika.medifirst2000.util.JsonUtil;
import com.jasamedika.medifirst2000.vo.FisisPemeriksaanDokterVO;
import com.jasamedika.medifirst2000.vo.FisisPemeriksaanDokterVO;

/**
 * Implement class for FisisPemeriksaanDokterService
 * 
 * @author Askur
 */
@Service("FisisPemeriksaanDokterService")
public class FisisPemeriksaanDokterServiceImpl implements FisisPemeriksaanDokterService<FisisPemeriksaanDokterVO> {
	@Autowired
	private FisisPemeriksaanDokterDao fisisPemeriksaanDokterDao;
	@Autowired
	private FisisPemeriksaanDokterConverter fisisPemeriksaanDokterConverter;

	@Override
	public Map<String,Object> addFisisPemeriksaanDokter(FisisPemeriksaanDokterVO vo) {
		Map<String,Object> result=new HashMap<String,Object>();
		FisisPemeriksaanDokter model=fisisPemeriksaanDokterConverter.transferVOToModel(vo, new FisisPemeriksaanDokter());
		FisisPemeriksaanDokter resultModel=fisisPemeriksaanDokterDao.save(model);
		try {
			result.put("fisisPemeriksaanDokter",JsonUtil.ToMap(resultModel));
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		}
		return result;
	}

	@Override
	public Map<String, Object> findFisisPemeriksaanDokterByNoRec(String noRec) {
		Map<String,Object> result=new HashMap<String,Object>();
		List<FisisPemeriksaanDokter> list=fisisPemeriksaanDokterDao.findFisisPemeriksaanDokterByNoRec(noRec);
		if(list.isEmpty()){
			result.put("dataFound", false);
		}else{
			result.put("dataFound", true);
			try {
				result.put("pemeriksaanFisis", JsonUtil.ToMapObject(list.get(0)));
			} catch (IllegalArgumentException e) {
				e.printStackTrace();
			} catch (IllegalAccessException e) {
				e.printStackTrace();
			}
		}
		return result;
	}

	@Override
	public FisisPemeriksaanDokterVO add(FisisPemeriksaanDokterVO vo) throws JpaSystemException, ServiceVOException {
		return null;
	}

	@Override
	public FisisPemeriksaanDokterVO update(FisisPemeriksaanDokterVO vo) throws JpaSystemException, ServiceVOException {
		return null;
	}

	@Override
	public Boolean delete(String key) throws JpaSystemException {
		return null;
	}

	@Override
	public FisisPemeriksaanDokterVO findById(String key) throws JpaSystemException {
		return null;
	}

	@Override
	public List<FisisPemeriksaanDokterVO> findAll() throws JpaSystemException {
		return null;
	}

	@Override
	public Map<String, Object> findAllWithPageAndLimitAndSortByAndDirectionParameter(Integer page, Integer limit,
			String sort, String dir) {
		return null;
	}	
}
